unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ActiveX, ExtCtrls, LblEffct;

{ ###################################################################### }
{                                                                        }
{ ATTENZIONE: Utenti di Borland Delphi 2.0                               }
{ Questo programma  stato realizzato con Delphi 3.0,                    }
{ bisogna necessariamente sostituire nella clausola uses l'unit ActiveX  }
{ con l'unit OLE2.                                                       }
{                                                                        }
{ /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\ }
{                                                                        }
{ by                                                                     }
{ Pier Carlo Chiodi                                                      }
{ pc.chiodi@mbox.thunder.it                                              }
{ http://pierky.thunder.it                                               }
{                                                                        }
{ ###################################################################### }

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit2: TEdit;
    Label5: TLabel;
    Edit3: TEdit;
    Label6: TLabel;
    Edit4: TEdit;
    Label7: TLabel;
    Edit5: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Bevel1: TBevel;
    Edit6: TEdit;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Memo1: TMemo;
    Button2: TButton;
    Label20: TLabelEffect;
    Label13: TLabel;
    Nome: TEdit;
    Label14: TLabel;
    Label15: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Label20Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var Guid:TGuid;
    szGuid:array[0..MAX_PATH] of Char;
    S:String;
    i:Longint;
    length:Longint;
begin
  // La chiamata alla funzione CoCreateGuid se ha successo
  // riempie una variabile di tipo TGUID; la dichiarazione di
  // questo type  specificata nell'unit OLE2:
  // type TGUID = record
  //   D1: Longint;
  //   D2: Word;
  //   D3: Word;
  //   D4: array[0..7] of Byte;
  // end;
  if CoCreateGuid(Guid) <> S_OK then
  begin
    // Se la funzione non ha successo, viene mostrato un
    // messaggio di errore.
    MessageBox(Form1.Handle,'Errore durante la creazione del GUID','GUIDGenerator',MB_APPLMODAL + MB_ICONERROR);
  end
  else
  begin
    // La procedura ZeroMemory riempie una variabile puntata
    // dal primo parametro e lunga MAX_PATH byte con il valore ZERO;
    // szGuid sarebbe una variabile di tanti caratteri nulli.
    ZeroMemory(@szGuid,MAX_PATH);

    // Una volta "svuotata" la variabile szGuid, bisogna chiamare
    // la funzione StringFromGUID2, che converte il valore
    // precedentemente ottenuto con CoCreateGuid in una stringa
    // OLE, puntanta nel secondo parametro. In effetti ho utilizzato
    // come stringa OLE un array di caratteri.

    length:=StringFromGUID2(Guid,@szGuid,MAX_PATH);

    // Per ottenere il valore in formato String da una stringa OLE
    // o WideChar bisogna ricorrere all'apposita funzione
    // WideCharToString, che necessita di un solo parametro, il
    // puntatore alla stringa OLE o WideChar, in questo caso
    // rappresentata dalla variabile szGuid.

    // WideChar  una particolare rappresentazione delle stringhe;
    // si interpone tra un carattere ed un altro un byte settato a
    // zero. La parola "CIAO" si tradurrebbe quindi in
    // 'C' + #0 + 'I' + #0 + 'A' + #0 + 'O'.
    S:=WideCharToString(@szGuid);

    // Ora non rimane altro da fare che visualizzare i vari valori
    // del GUID appena generato e convertito in stringa negli appositi
    // campi di testo posizionati sulla form.

    // Il primo campo contiene l'intero GUID tradotto in stringa.
    Edit1.Text:=S;

    // Gli altri tre campi contengono i valori delle variabili D1, D2 e
    // D3 che fanno parte del GUID.
    Edit2.Text:='$' + IntToHex(Guid.D1,8);
    Edit3.Text:='$' + IntToHex(Guid.D2,4);
    Edit4.Text:='$' + IntToHex(Guid.D3,4);

    // L'ultimo campo, invece, contiene il valore della variabile D4,
    // un'array formata da 8 byte.
    Edit5.Text:='(';
    for i:= 0 to 6 do
    begin
      Edit5.Text:=Edit5.Text + '$' + IntToHex(Guid.D4[i],2) + ', ';
    end;
    Edit5.Text:=Edit5.Text + '$' + IntToHex(Guid.D4[7],2) + ')';

    // Nel campo Edit6 inserisco la traduzione in Delphi per la
    // dichiarazione di una costante in formato TGUID.
    Edit6.Text:='const ' + Nome.Text + ' : TGUID = ' + '(D1:' + Edit2.Text + '; D2:' + Edit3.Text + '; D3:' + Edit4.Text + '; D4:' + Edit5.Text + ');';

    // Nel campo Memo1 visualizzo la dichiarazione in Delphi di una
    // variabile di tipo TGUID.
    Memo1.Lines.Clear;
    Memo1.Lines.Add(Nome.Text + '.D1:= ' + Edit2.Text + ';');
    Memo1.Lines.Add(Nome.Text + '.D2:= ' + Edit3.Text + ';');
    Memo1.Lines.Add(Nome.Text + '.D3:= ' + Edit4.Text + ';');
    for i:= 0 to 7 do
      Memo1.Lines.Add(Nome.Text + '.D4[' + IntToStr(i) + ']:= ' + '$' + IntToHex(Guid.D4[i],2) + ';');
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Bevel1.Width:=Edit1.Width;
  Bevel2.Width:=Edit1.Width;
  Bevel3.Width:=Edit1.Width;
end;

procedure TForm1.Label20Click(Sender: TObject);
begin
  MessageBox(Form1.Handle,pChar('By Pier Carlo Chiodi' + #13 + #13 + 'E-Mail: pc.chiodi@mbox.thunder.it' + #13 + 'Home page: http://pierky.thunder.it'),'GUID generator',MB_APPLMODAL + MB_ICONINFORMATION);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Close;
end;

end.
